#pragma title ("CW MQM examples - cw_put1.c")

/*-----------------------------------------------------+
| MVS (OS/390) only pragma(s).                         |
+-----------------------------------------------------*/

#ifdef MVS
#pragma runopts(ENV(MVS),PLIST(MVS),NOEXECOPS,\
NOTEST(NONE,INSPICD,PROMPT) )

#pragma csect(code,"CW_MAIN")
#pragma csect(static,"CW_WS")

#pragma comment( copyright , "Roger Lacroix" )
#endif

#pragma subtitle( "Load module eye-catchers" )

/*-----------------------------------------------------+
| Program build time eye-catchers for executable.      |
+-----------------------------------------------------*/

static const char * EYECATCHER_EyeCatcher  = "cw_put1 " ;
static const char * EYECATCHER_Version     = "01.00.00" ;
static const char * EYECATCHER_Datestamp   = __DATE__ ;
static const char * EYECATCHER_Timestamp   = __TIME__ ;
static const char * EYECATCHER_Filename    = __FILE__ ;

#pragma subtitle ("Change History")
#pragma page ()

      /*----------------------------------------------------+
      | CHANGE HISTORY for CW MQM Example code.             |
      | Change codes are written in column 73-78.           |
      |-----------------------------------------------------|
      | Date       Change-id   Produced     SCR number.     |
      | yyyymmdd               Version.                     |
      |                        rr.ss.uu                     |
      | Reason                                              |
      |-----------------------------------------------------|
      | 19980601   R. Lacroix  01.00.00                     |
      | Birth.                                              |
      |                                                     |
      |                                                     |
      +----------------------------------------------------*/

#pragma subtitle ("Program Description")
#pragma page ()

      /*----------------------------------------------------+
      | Program:  CW MQM Examples                           |
      |                                                     |
      | Purpose:  Examples show show the use of CW MQM      |
      |           common code.                              |
      |                                                     |
      +----------------------------------------------------*/

#pragma subtitle ("Include Files")
#pragma page ()

      /*----------------------------------------------------+
      | System include files.                               |
      +----------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

      /*----------------------------------------------------+
      | MQM include files.                                  |
      +----------------------------------------------------*/

#include "cmqc.h"           // general MQM definitions

      /*----------------------------------------------------+
      | CW include files.                                   |
      +----------------------------------------------------*/

#include "cwmqm.h"         // common CW MQM definitions

      /*----------------------------------------------------+
      | general purpose defines.                            |
      +----------------------------------------------------*/

#define  DEFAULT_QUEUE_MGR_NAME  \
                   "MQT1                                            "
#define  DEFAULT_QUEUE_NAME      \
                   "SYSTEM.DEFAULT.LOCAL.QUEUE                      "
#define  BLANK_48  "                                                "

      /*----------------------------------------------------+
      | Prototypes.                                         |
      +----------------------------------------------------*/

static CW_RC_T DoPutMessage( void );
static CW_RC_T DoPutOneMessage( void );


#pragma subtitle ("Global Areas")
#pragma page ()

      /*----------------------------------------------------+
      | Global Areas.                                       |
      +----------------------------------------------------*/

   MQHCONN           LocalMqmHandle;



#pragma subtitle ("Mainline")
#pragma page ()

      /*----------------------------------------------------+
      | Routine : Examples                                  |
      |                                                     |
      | Purpose:                                            |
      | The mainline of this program is to should how       |
      | to use the common CW MQM routines.                  |
      |                                                     |
      | Input:                                              |
      |  None.                                              |
      |                                                     |
      | Output:                                             |
      |  None.                                              |
      |                                                     |
      | Messages:                                           |
      |  None.                                              |
      |                                                     |
      | Return codes:                                       |
      |  CW_RC_OK     - terminated successfully.            |
      |  CW_RC_FAILED - terminating with error.             |
      |                                                     |
      | Abend Codes:                                        |
      |  None.                                              |
      |                                                     |
      | Called Routines:                                    |
      |                                                     |
      +----------------------------------------------------*/

extern int main ( )
{
   /*------------------------------------------------------+
   | Variable declarations.                                |
   +------------------------------------------------------*/

   auto   CW_RC_T    CwRC;         /* function return code        */

   auto   QUEUE_NAME  QueueMgrName;

   auto   QUEUE_NAME  QueueName;

   auto   QUEUE_NAME  ReplyToQMgrName;

   auto   QUEUE_NAME  ReplyToQueueName;

   auto   char       *WorkMsgPtr;

   auto   int         WorkMsgSize;

   /*------------------------------------------------------+
   | Constant definitions.                                 |
   +------------------------------------------------------*/

   /*------------------------------------------------------+
   | Code section                                          |
   +------------------------------------------------------*/

   CwRC = CW_RC_OK;        /* Assume that the return code is OK. */

   printf("Starting...\n");

   /*-------------------------------------------------------+
   | Set the name of the queue manager.                     |
   +-------------------------------------------------------*/

   memcpy( QueueMgrName,
           DEFAULT_QUEUE_MGR_NAME,
           sizeof(QueueMgrName) );

   /*------------------------------------------------------+
   | Make sure we have a connection to MQM.                |
   +------------------------------------------------------*/

   CwRC = CW_ConnectToMqm( QueueMgrName );

   /*-------------------------------------------------------+
   | Set the name of the queue.                             |
   +-------------------------------------------------------*/

   memcpy( QueueName,
           DEFAULT_QUEUE_NAME,
           sizeof(QueueName) );

   /*-------------------------------------------------------+
   | Build a message.                                       |
   +-------------------------------------------------------*/

   WorkMsgPtr = malloc( 1024 );  /* allocate 1kb of memory */

   strcpy( WorkMsgPtr,
   "This is an example of a CW_SendOneMqmMessage function - MQPUT1" );

   WorkMsgSize = strlen( WorkMsgPtr );

   /*-------------------------------------------------------+
   | Clear the reply to queue manager name and queue name.  |
   | We don't need it in this example.                      |
   +-------------------------------------------------------*/

   memcpy( ReplyToQMgrName,
           BLANK_48,
           sizeof(ReplyToQMgrName) );

   memcpy( ReplyToQueueName,
           DEFAULT_QUEUE_NAME,
           sizeof(ReplyToQueueName) );

   /*-------------------------------------------------------+
   | Send the message using MQPUT1.                         |
   +-------------------------------------------------------*/

   CwRC = CW_SendOneMqmMessage( QueueMgrName,
                                QueueName,
                                ReplyToQMgrName,
                                ReplyToQueueName,
                                WorkMsgPtr,
                                WorkMsgSize );

   /*-------------------------------------------------------+
   | Time to lose the memory.                               |
   +-------------------------------------------------------*/

   free( WorkMsgPtr );

   /*-------------------------------------------------------+
   | Disconnect from the queue manager.                     |
   +-------------------------------------------------------*/

   CwRC = CW_DisconnectFromMqm( );

   return ( CwRC );
}

#pragma subtitle ("Function Include Files")
#pragma page ()

   /*------------------------------------------------------+
   | Include the MQM routines.                             |
   +------------------------------------------------------*/

#include "cwmqm.c"

